/*******************************************************************************

Author : Mauro Laurenti
Version : 1.2

Created on Date : 04/09/2006
Last update     : 20/10/2013

CopyRight 2006-2013 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

*******************************************************************************/


#ifdef __XC8
    #include <xc.h>
#endif

#ifndef __XC8
  #include <delays.h>
#endif


#include <delay.h>

unsigned char delay_quartz_frequency_value = 20;
unsigned int clock_counter_reference = 0;

//************************************************************
//             delay_ms function implementation
//************************************************************



void delay_ms (unsigned int value_ms) {
		      
	clock_counter_reference = value_ms * delay_quartz_frequency_value;


        while (clock_counter_reference) {
            #ifndef __XC8
                //1ms Delay at 1MHz trimmed down to 24 instead of 25
                //to compensate the main loop
                Delay10TCYx (24);
            #endif

            #ifdef __XC8
                //1ms Delay at 1MHz trimmed down to 240 instead of 250
                //to compensate the main loop
                _delay(240);
            #endif

            clock_counter_reference--;
	}	
}

//************************************************************
//             delay_s function implementation
//************************************************************

void delay_s (unsigned char value_s) {

	unsigned char repeat_loop;

	for (repeat_loop = 0; repeat_loop < value_s; repeat_loop++)
		delay_ms (1000);
}


//************************************************************
//             setQuartz function implementation
//************************************************************

void setQuartz (unsigned char frequency) {

	delay_quartz_frequency_value = frequency;
	
} 

