#include <xc.h>
#include "delay.c"
#include "PIC18F4550_config.h"
#define LCD_DEFAULT
#include "LCD_44780.c"


int main(void) {

       // Variabile per salvare la sommatoria dei dati letti
	unsigned int sommatoria = 0;

	// Variabile per salvare il valore della conversione
	int lettura = 0;

	// Variabile utilizzata per il numero delle letture
	char i;

         // Imposto PORTA tutti ingressi
	LATA = 0x00;
 	TRISA = 0xFF;

	// Imposto PORTB tutti ingressi
 	LATB = 0x00;
 	TRISB = 0xFF;

	// Imposto PORTC tutti ingressi
 	LATC = 0x00;
 	TRISC = 0b11111101;

	// Imposto PORTD tutte uscite
 	LATD = 0x00;
 	TRISD = 0x00;

	// Imposto PORTE tutti ingressi
 	LATE = 0x00;
 	TRISE = 0xFF;

        // Abilito AN0-AN1-AN2 come ingressi analogici
 	// VREF sono impostate a massa e VCC
	ADCON1=0b00001101;

	// Seleziono Trimmer
	 ADCON0=0b00000100;

	// Imposto i tempi di conversione e giustificazione a destra
	// TAD : FOSC/64
	// TACQ: 20 TAD
	ADCON2 = 0b10111110;

	// Abilito l' ADC
	ADCON0bits.ADON = 0x01;

 	// Inizializzazione LCD
 	OpenLCD (20);
 	BacklightLCD (TURN_ON_LED_LCD);

 	WriteStringLCD ("   Lux : ");

	// Ciclo infinito
 	while (1) {

	 	sommatoria = 0;

		// Effettuo 32 letture per fare una media
		for (i =0; i<32; i++){

			// Avvio la conversione Analogico/Digitale
			ADCON0bits.GO = 1;

			// Attendo la fine della conversione
			while(ADCON0bits.GO);

			// Prelevo il valore della conversione
			lettura = (((int) ADRESH) << 8) | ADRESL;

			// Sommatoria delle letture fatte
			sommatoria = sommatoria + lettura;

		}

	// 5 shift per la media
	sommatoria = sommatoria >> 5;

	WriteIntLCD (sommatoria,4);

	goto_xy_LCD (10,1);

	}
}


